// ELF compatibility interpreter

#include <linux/interpreter.h>
#include <linux/module.h>

static char *interpreter = "/lib/ld-linux-x86-64.so.2";
module_param(interpreter, charp, 0444);
MODULE_PARM_DESC(interpreter, "ELF compatibility interpreter");

static const char *elf_compat_alternative_name(const char *name) {
	return strcmp(name, "/lib64/ld-linux-x86-64.so.2") ? NULL : interpreter;
}

static struct linux_interpreter elf_compat_interpreter = {
	.module = THIS_MODULE,
	.alternative_name = elf_compat_alternative_name
};

static int __init init_elf_compat_interpreter(void) {
	return register_interpreter(&elf_compat_interpreter);
}

static void __exit exit_elf_compat_interpreter(void) {
	unregister_interpreter(&elf_compat_interpreter);
}

core_initcall(init_elf_compat_interpreter);
module_exit(exit_elf_compat_interpreter);
MODULE_LICENSE("GPL");
